!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!   PNJPUERTAS		Una libreria para InformATE complementaria a PNJMovil
!			para la codificacin sencilla de puertas
!			utilizables por los PNJs.
!			Escrita por Jvius. <jaevius@teleline.es>
!
!			Basada en una traduccin y adaptacin de la
!			libreria DOORS de L. Ross Raszewski.<rraszews@skipjack.bluecrab.org>
!			
!	La documentacin sobre el uso de la librera se incluyen en el
!	archivo adjunto PNJPuertas.txt, dado su extensin.


property tras_abrir;	
Constant DEJA_ALEATORIO =0;
Constant DEJA_ABIERTO =1;
Constant DEJA_CERRADO =2;
Constant DEJA_CERRADO_CON =3;
Constant NO_PUEDE_ABRIR =4;


Class PnjPuerta
            with 
	    nombre_f 'puerta',
	    nombre_fp 'puertas',	
	    direcc_puerta [; if (parent(self)==self.ladoa) 
                                                return self.dira;
                                                return self.dirb;
                       ],
            puerta_a  [; if (parent(self)==self.ladoa) 
                                                return self.ladob;
                                                return self.ladoa;
                       ],
	    
             ladoa 0,
             dira 0,
             ladob 0,
             dirb 0,
             esta_en 0 0,

	     lado_cierre 0,
	     bloqueada false,

	     pnj_abrir [quien res x;
			
		if (self has abierta) res=0;else 
		
		if(quien.tras_abrir==NO_PUEDE_ABRIR){
			if(pruebadealcance(quien))print(_El)quien," quiere abrir ",(el)self,", pero no puede.^";else
			if(pruebadealcance(self))print"Se oyen ruidos al otro lado de ",(el)self,",como si algo intentara abrirla.^";
			rfalse;} else

		if (self hasnt cerrojoechado) res=7; 	 
		else				
			if (self provides con_llave)	
				if (self.con_llave in quien)	
					if(self.lado_cierre==0 || quien in self.lado_cierre) res=1;
					else
					res=2;
				else
					if(self.lado_cierre==0 || quien in self.lado_cierre) res=3;
					else
				 	res=4;
			else
				if(self.lado_cierre==0 || quien in self.lado_cierre)res=5;
				else
				res=6;
		

		if (self.bloqueada) switch(res){
					1: res=8;
					5: res=9;
					7: res=10;
					}

!******	YA TENEMOS EN RES CODIFICADO EL RESULTADO DEL MOVIMIENTO DEL PNJ
!	EN RELACION CON LA PUERTA. Los cdigos son:
!	0.- Puerta abierta.- Pnj pasa sin problema
!	1.- Puerta cerrada con llave y PNJ tienen la llave.- pasa sin problema
!	2.-  "		"	"	"	"	" ,pero no hay cerradura a este lado.- no pasa
!	3.-  "		"	"	"  no tiene la llave. No pasa.
!	4.-  "		"	"	"   " 	" 	"   , adems no hay cerradura aqu. No pasa.
!	5.-  Puerta cerrada con pestillo y est al alcance del PNJ.- Pasa.
!	6.-  "		"	"	Y NO est al alcance pnj. No pasa.
!	7.-  Puerta cerrada pero sin llave ni pestillo. Pasa.
!	8, 9 y 10 corresponden a 1, 5 y 7 (nicos casos en los que el
!	pnj atravesara la puerta abriendola), cuando sta se ha bloqueado. No
!	pasan.
!************* AHORA DESCRIBIMOS LA ACCION -SI SE VE EL PNJ O LA PUERTA...

		print"^";
		if(pruebadealcance(quien))
			switch(res){
		0:print (_El)quien," sale por ",(el)self,".^";
		1:print (_El)quien," abre con ",(un)self.con_llave," ",(el)self," y sale por ell",(o)self,".^";
		2,3,4,6:print (_El)quien," intenta abrir ",(el) self," pero parece cerrad",(o)self,".^";
		5:print (_El)quien," abre ",(el)self," accionando el pestillo, y sale por ell",(o)self,".^";
		7:print (_El) quien, " abre ",(el)self," y sale por ell",(o)self,".^";
		8:print (_El)quien," intenta abrir con ",(un)self.con_llave," ",(el)self,", pero parece que algo la atranca.";
		9:print (_El)quien," acciona el pestillo de ",(el)self," pero algo impide que l",(o)self," abra.";
		10:print (_El) quien, " intenta abrir ",(el)self," pero parece atascada con algo.^";
		}else

		if(pruebadealcance(self))
			switch(res){
		0:print (_El)quien," entra por ",(el)self,".^";
		1:print "Oyes abrirse una cerradura, y  ",(el)self, " se abre entrando ",(el) quien,".^";
		2,3,4,6,8,9,10:print "Alguien intenta abrir ",(el)self," sin conseguirlo.^";
		5:print  "Oyes descorrer un pestillo, y ",(el)self, " se abre entrando ",(el) quien,".^"; 	
		7:print (_El)self," se abre y entra ",(el)quien," por ell",(o)self,".^";
				}
	

	
!*********************** ESTADO DE LA PUERTA TRAS ABRIRLA ******************************
! EN FUNCION DE LA PROPIEDAD TRAS_ABRIR DEL PNJMovil... 


	if(res==0 && self hasnt abrible)rtrue;
	
	!si la puerta estaba abierta y no es abrible - no es necesario ejecutar codigo de cierre...
	!esto permite crear entradas como arcos, dinteles, etc, sin puerta propiamente dicha.

	x=0;
	if(quien provides tras_abrir)
	x=quien.tras_abrir;
	
	if(x==DEJA_ALEATORIO)x=random(3);
	
!PRIMERO IMPRIMIMOS EL MENSAJE SI LA ACCION ES VISIBLE POR EL JUGADOR
	
	if(pruebadealcance(self) || pruebadealcance(quien))
	{
	if(x==DEJA_CERRADO && res==0 or 1 or 5 or 7)
			print (_El)quien," cierra ",(el)self,".^";


	if (x==DEJA_CERRADO_CON && res==0 or 1 or 5 or 7)
		{
		print (_El)quien," cierra ",(el)self;

		if( self.lado_cierre ==parent(quien))
		print".^";
		else
		switch(res){
		0, 7:	if(self provides con_llave)
				if(self.con_llave in quien ){
				print" con llave.^";}
				else print".^";
		  	else 
			if(self has cerrojo)
			 print" echandole el pestillo.^";
		    	else
			    print ".^";
		  
			
		1:	print" con llave.^";
	
		5:	print" echandole el pestillo.^";
	
		} !fin de switch

		} !fin de if(x==deja_cerrado_con

		} !fin de if(pruebadealcance....



!AHORA EJECUTAMOS EL RESULTADO DE TODO EL PROCESO **************************


	switch (res){
		0:
		if(x==DEJA_CERRADO or DEJA_CERRADO_CON)give self ~abierta;
		if(x==DEJA_CERRADO_CON && self.lado_cierre~=parent(quien))
			if(self provides con_llave)
				if(self.con_llave in quien)give self cerrojoechado;else rtrue;
			else if(self has cerrojo)give self cerrojoechado;
		rtrue;

		1,5:
		if(x==DEJA_ABIERTO or DEJA_CERRADO)give self ~cerrojoechado;
		if(x==DEJA_ABIERTO)give self abierta;
		if(x==DEJA_CERRADO_CON && self.lado_cierre~=0)give self ~cerrojoechado;
		rtrue;

		7:
		if(x==DEJA_ABIERTO) give self abierta;
		if(x==DEJA_CERRADO_CON && self.lado_cierre~=parent(quien))
			if(self provides con_llave)
				if(self.con_llave in quien)give self cerrojoechado;else rtrue;
			else if(self has cerrojo)give self cerrojoechado;
		rtrue;

		default:
		rfalse;

		}

		],
			
	antes[;
	
		abrir,cerrar: 
			if(self.bloqueada){
				print "^Algo bloquea ",(el)self,
				" impidiendo que l",(o)self;
				if(accion==##abrir) " abras.";else
				" cierres.";}
	
		abrir:
			if(self provides con_llave)rfalse; else
			if(self has cerrojo && self has cerrojoechado)
				"^Est cerrada con un pestillo.^";
				
		!Corrige un defecto de la libreria.- en puertas cerradas con pestillo, al intentar
		!abrirlas te informaba que estaban cerradas con llave.
		!(supongo que un problema de traduccion (...lock)

		echarcerrojo,quitarcerrojo:
			if (self.lado_cierre==0 ||self.lado_cierre ==localizacion)rfalse;
			else
			{if(self provides con_llave)"No hay cerradura a este lado de ",(el)self,".^";
			"No existe pestillo a este lado de ",(el)self,".^";}
			
		!el lado_cierre afecta tanto a los Pnjs como al jugador
		
		examinar:
			if(self provides descripcion)ImprimirOEjecutar(self,descripcion);
			else
			print "^";
			
			if (self.lado_cierre==0 || localizacion==self.lado_cierre)
				if (self provides con_llave) print (_El) self," puede abrirse y cerrarse desde aqu con una llave.^";
				else 
				if(self has cerrojo)print (_El) self," puede abrirse y cerrarse desde aqu con un pestillo.^";
			if(self has abrible) 
				if(self has abierta)"Ahora est abierta.^";
				else "Est cerrada.^";
			rtrue;
				
		],

		

        has puerta estatico ;

	

[ IniciarPuertas o i j ;
        objectloop (j ofclass PnjPuerta) { 
                objectloop (o in brujula)
                                { i=o.direcc_puerta;
                                  if (j provides i)
                                        { j.ladoa=j.i;
                                          j.dirb=i;
                                        };
                                  };
                            objectloop (o in brujula)
                                { i=o.direcc_puerta;
                                  if ((j provides i) && (j.dirb~=i))
                                        { j.ladob=j.i;
                                          j.dira=i;
                                        };
                                  };
                            j.&esta_en-->0=j.ladoa;
                            j.&esta_en-->1=j.ladob;

        };
];




